#include <xc.h>

int timePeriod;
int temp;

void _ISR _T1Interrupt(void)
{
	IFS0bits.T1IF = 0; // Clear Timer1 Interrupt Flag
}

void _ISR _OC1Interrupt(void)
{
	IFS0bits.OC1IF = 0;
}

void _ISR _IC1Interrupt(void)
{	//uses TMR3
	//PORTBbits.RB10 	= ~PORTBbits.RB10;	//used to see if interrupt triggers
	unsigned int t1,t2;

 	t2=IC1BUF;
 	t1=IC1BUF;
 	IFS0bits.IC1IF =0;
 	
  	timePeriod = (t2-t1)*(-1);
 	temp = timePeriod;
	if(temp >= 32 && temp <= 36){//filter and then assign
		PR2 = temp *2;		//set the Period Register for PWM aproximately 34 (measured)
		OC1R = temp;		//set OC1R register aproximately 16 (from measured)
	}	

    _IC1IF 			= 0;				// Reset respective interrupt flag
}

main( void)
{ 
 //Set Oscillator Configuration------------------------------------------
 OSCCON = 0x0100; 				//0000001100000000  
 CLKDIV = 0x0000; 				//
 PLLFBD = 0x0054; 				//4MHz crystal /86 ==> 43MIPS
 //----------------------------------------------------------------------
 TRISBbits.TRISB10 	= 0; 		//Debug Output
 //unlock peripheral select----------------------------------------------
 OSCCON = 0x46;
 OSCCON = 0x57;
 OSCCONbits.IOLOCK 	= 0;		//unlock
 RPINR7bits.IC1R  	= 6;		//Tie IC1 module to RP6 pin 15
 RPOR2bits.RP5R		= 0b10010;	//OC1 tied to RP5
 OSCCONbits.IOLOCK 	= 1;		//lock
 //setup IC1 module======================================================
 IPC0bits.IC1IP 	= 7; 		// Set module interrupt priority as 7
 IC1CONbits.ICSIDL 	= 0; 		// Input capture will continue to operate in CPU idle mode
 IC1CONbits.ICTMR 	= 0;;		// TMR3 contents are captured on capture event
 IC1CONbits.ICI		= 0;	 	// Interrupt on every capture event *** DO NOT CHANGE ***
 IC1CONbits.ICM 	= 0b011; 	// Capture mode, every rising edge
 IFS0bits.IC1IF 	= 0; 		// Clear the IC1 interrupt status flag
 IEC0bits.IC1IE 	= 1; 		// Enable IC1 interrupt
 //Initialize Timer3-------------------------------------------------------
 T3CONbits.TON 		= 0; 		// Disable Timer3
 T3CONbits.TCS 		= 0; 		// Select internal instruction cycle clock
 T3CONbits.TGATE 	= 0; 		// Disable Gated Timer mode
 T3CONbits.TCKPS 	= 0b00; 	// Select 1:1 Prescaler
 TMR3 				= 0x00; 	// Clear timer register
 PR3 				= 1024; 	// Load the initial period value 
 IPC2bits.T3IP 		= 0x01; 	// Set Timer3 Interrupt Priority Level
 IFS0bits.T3IF 		= 0; 		// Clear Timer3 Interrupt Flag
 IEC0bits.T3IE 		= 1; 		// Enable Timer3 interrupt
 T3CONbits.TON 		= 1; 		// Start Timer3
 //Initialize Output Compare================================================
 T2CONbits.TON 		= 0; 		// Disable Timer2
 OC1CON 			= 0x0000; 	// Turn off Output Compare 1 Module
 OC1CON 			= 0x0006; 	// Load new compare mode to OC1CON 0000000000000110
 OC1R 				= 0x0500; 	// Initialize Compare Register1 with 0x0500
 IPC0bits.OC1IP0 	= 1; 		// Setup Output Compare 1 interrupt for
 IPC0bits.OC1IP1 	= 0; 		// desired priority level
 IPC0bits.OC1IP2 	= 0; 		// (this example assigns level 1 priority)
 IFS0bits.OC1IF 	= 0; 		// Clear Output Compare 1 interrupt flag
 IEC0bits.OC1IE 	= 1; 		// Enable Output Compare 1 interrupts
 //Initialize Timer2--------------------------------------------------------
 T2CONbits.TCS 		= 0; 		// Select internal instruction cycle clock
 T2CONbits.TGATE 	= 0; 		// Disable Gated Timer mode
 T2CONbits.TCKPS 	= 0b00; 	// Select 1:1 Prescaler
 TMR2 				= 0x00; 	// Clear timer register
 PR2 				= 9; 		// Load the initial period value  *CAN THIS BE CHANGED WHILE THE TIMER IS RUNNING?*
 IPC1bits.T2IP 		= 0x01; 	// Set Timer1 Interrupt Priority Level
 IFS0bits.T2IF 		= 0; 		// Clear Timer1 Interrupt Flag
 IEC0bits.T2IE 		= 1; 		// Enable Timer1 interrupt
 T2CONbits.TON 		= 1; 		// Start Timer2
 //=========================================================================

 while(1)
 {
 
 }

}// main

 